"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.seekToTimeMultipleUntilRight = exports.seekToTime = void 0;
const seekToTime = (element, desiredTime) => {
    element.currentTime = desiredTime;
    let cancel;
    const prom = new Promise((resolve) => {
        cancel = element.requestVideoFrameCallback((_cb, metadata) => {
            resolve(metadata.mediaTime);
        });
    });
    return {
        wait: prom,
        cancel: () => {
            element.cancelVideoFrameCallback(cancel);
        },
    };
};
exports.seekToTime = seekToTime;
const seekToTimeMultipleUntilRight = (element, desiredTime, fps) => {
    const threshold = 1 / fps / 2;
    let currentCancel = () => undefined;
    const prom = new Promise((resolve, reject) => {
        const firstSeek = (0, exports.seekToTime)(element, desiredTime + threshold);
        firstSeek.wait.then((seekedTo) => {
            const difference = Math.abs(desiredTime - seekedTo);
            const ident = Math.random();
            if (difference < threshold) {
                return resolve();
            }
            const sign = desiredTime > seekedTo ? 1 : -1;
            const newSeek = (0, exports.seekToTime)(element, seekedTo + threshold * sign);
            currentCancel = newSeek.cancel;
            newSeek.wait
                .then((newTime) => {
                const newDifference = Math.abs(desiredTime - newTime);
                console.log(ident, 'before', seekedTo, 'after', newTime, 'desired', desiredTime);
                if (newDifference < threshold) {
                    return resolve();
                }
                const thirdSeek = (0, exports.seekToTime)(element, desiredTime);
                currentCancel = thirdSeek.cancel;
                thirdSeek.wait.then(() => {
                    resolve();
                });
            })
                .catch((err) => {
                reject(err);
            });
        });
        currentCancel = firstSeek.cancel;
    });
    return {
        prom,
        cancel: () => {
            currentCancel();
        },
    };
};
exports.seekToTimeMultipleUntilRight = seekToTimeMultipleUntilRight;
